/* # skkinput (Simple Kana-Kanji Input)
 *
 * This file is part of skkinput.
 * Copyright (C) 2002
 * Takashi SAKAMOTO (PXG01715@nifty.ne.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#if !defined (TNormalFrameP_h)
#define	TNormalFrameP_h

#include "TFrameP.h"
#include "TNormalFrame.h"

typedef struct tagTNormalFramePart {
	Widget					m_wgPopup ;
	Widget					m_wgTerminal ;
	XtCallbackList			m_lstCbkKeyPress ;
	XtCallbackList			m_lstCbkConfigure ;
}	TNormalFramePart ;

typedef struct tagTNormalFrameRec {
	CorePart				core ;
	CompositePart			composite ;
	ShellPart				shell ;
	TFramePart				tframe ;
	TNormalFramePart		tnormalframe ;
}	TNormalFrameRec ;

typedef struct {
	int						dummy ;
}	TNormalFrameClassPart ;

typedef struct tagTNormalFrameClassRec {
	CoreClassPart			core_class ;
	CompositeClassPart		composite_class ;
	ShellClassPart			shell_class ;
	TFrameClassPart			tframe_class ;
	TNormalFrameClassPart	tnormalframe_class ;
}	TNormalFrameClassRec ;

extern TNormalFrameClassRec	tnormalFrameClassRec ;

#endif

